#-------------------------------------------------------------------------------
# 
# === fc2upd ===
# 
# Auther: MAO
# http://mao.nyanta.jp/
# 
#-------------------------------------------------------------------------------

import sys
import os
import re
import urllib
import urllib2
import cookielib
import shutil

import poster

#-------------------------------------------------------------------------------
debuglevel = 0

cj = cookielib.CookieJar()
opener = urllib2.build_opener(
  urllib2.HTTPHandler(debuglevel = debuglevel),
  urllib2.HTTPSHandler(debuglevel = debuglevel),
  urllib2.HTTPCookieProcessor(cj)
)
multipart_opener = urllib2.build_opener(
  poster.streaminghttp.StreamingHTTPHandler(debuglevel = debuglevel),
  poster.streaminghttp.StreamingHTTPRedirectHandler(),
  urllib2.HTTPCookieProcessor(cj)
)

#-------------------------------------------------------------------------------
class Abort(Exception):
  pass

#-------------------------------------------------------------------------------
def login(email, passwd):
  
  params = {
    'email' : email,
    'pass' : passwd,
  }
  
  res = opener.open(
    'https://secure.id.fc2.com/index.php?mode=login&switch_language=ja',
    urllib.urlencode(params)
  )
  res.read()
  
  res = opener.open('http://id.fc2.com/?login=done')
  content = res.read()
  m = re.search(r'(http://blog\.fc2\.com/\?control[^"]+)', content)
  if m is None:
    raise Abort('Login Failed')
  
  res = opener.open(m.group(1))
  m = re.search(r'(http://blog\d+\.fc2\.com)/control\.php', res.url)
  if m is None:
    raise Abort('Maybe the login system has changed...')
  
  return m.group(1)

#-------------------------------------------------------------------------------
def get_crc(blog_host):
  
  res = opener.open(blog_host + '/control.php?mode=control&process=upload')
  m = re.search(r'name="crc" +value="(\w+)"', res.read())
  if m is None:
    raise Abort('Get CRC Failed')
  
  return m.group(1)

#-------------------------------------------------------------------------------
def move_finished_files(dirname, filenames):
  
  finished_dir = os.path.join(dirname, 'finished')
  if os.path.exists(finished_dir):
    for filename in filenames:
      dest = os.path.join(finished_dir, filename)
      if os.path.exists(dest):
        os.remove(dest)
      shutil.move(os.path.join(dirname, filename), finished_dir)

#-------------------------------------------------------------------------------
def upload_files(blog_host, crc, dirname, filenames):
  
  print 'Uploading files ...'
  print '\n'.join(filenames)
  
  params = []
  for filename in filenames:
    upfile_param = poster.encode.MultipartParam(
      'upfile[]',
      filename = filename,
      fileobj = file(os.path.join(dirname, filename), 'rb'),
    )
    upfile_param.name = 'upfile[]'
    params.append(upfile_param)
  
  params += [
    ('width', '120'),
    ('height', '120'),
    ('overwrite', 'force'),
    ('MAX_FILE_SIZE', '512000'),
    ('mode', 'control'),
    ('process', 'upload'),
    ('type', 'upload'),
    ('crc', crc),
    ('insert', ''),
  ]
  datagen, headers = poster.encode.multipart_encode(params)
  req = urllib2.Request(
    blog_host + '/control.php?page=1&mode=control&process=upload&sort=dd', 
    datagen, headers
  )
  res = multipart_opener.open(req)
  res.read()
  
  for param in params:
    if hasattr(param, 'fileobj'):
      param.fileobj.close()
  move_finished_files(dirname, filenames)

#-------------------------------------------------------------------------------
def upload(blog_host, crc, dirname):
  
  filenames = []
  for filename in os.listdir(dirname):
    if not os.path.isfile(os.path.join(dirname, filename)):
      continue
    
    res = opener.open(
      blog_host + '/control.php?mode=control&process=upload&type=check&names=' + filename
    )
    if res.read() != 'true':
      filenames.append(filename)
    else:
      print 'Skip upload ' + filename
      move_finished_files(dirname, [filename])
    if len(filenames) == 6:
      upload_files(blog_host, crc, dirname, filenames)
      filenames = []
  if len(filenames) > 0:
    upload_files(blog_host, crc, dirname, filenames)

#-------------------------------------------------------------------------------
def main():
  
  if len(sys.argv) != 4:
    print 'Usage: fc2upd [email] [password] [dirname]'
    return
  
  (email, passwd, dirname) = sys.argv[1:]
  
  print 'Logining in ...'
  blog_host = login(email, passwd)
  print 'Your Blog Host is ' + blog_host
  res = opener.open(blog_host + '/control.php')
  res.read()
  print 'Getting CRC ...'
  crc = get_crc(blog_host)
  upload(blog_host, crc, dirname)

#-------------------------------------------------------------------------------
if __name__ == '__main__':
 main()
